--Script by Waigie (url: https://forum.runesofmagic.com/showthread.php?t=228037 )
--license: http://creativecommons.org/licenses/by-nc-sa/3.0/

--
-- Testmodule initialisation, this script is called via autoload mechanism when the
-- TeamSpeak 3 client starts.
--

require("ts3init")            -- Required for ts3RegisterModule
require("TS3Viewer/events")  -- Forwarded TeamSpeak 3 callbacks

local registeredEvents = {
	onConnectStatusChangeEvent = ts3overlay_events.onConnectStatusChangeEvent,
	onTalkStatusChangeEvent = ts3overlay_events.onTalkStatusChangeEvent
}

-- Register your callback functions with a unique module name.
ts3RegisterModule("ts3overlay", registeredEvents)
